# frozen_string_literal: true

module Hermes
  module Api
    module Dmo
      # checker Api::Dmo::HermesController avant d'ajouter des methodes
      class EligibleCountOffersController < Hermes::Api::Dmo::ApplicationController

        class << self
          def mutate_params
            {
 
            }
          end 
      
          def acceptable_params
            {
              housing_offer_id: {type: 'String'},
              created_at: {type: 'String'},
              offer_status: {type: 'String'},
              updated_at: {type: 'String'},
            }.merge(self.mutate_params).merge(super)
          end 
      
          def regex_params
            {
      
            }
          end 
        end

        def can_see
          !(current_user_roles & ['Administrator', 'superadministrateur']).empty?
        end 

        def show 
          return render_json_error(:unauthorized, :cannot_see) unless can_see

          super 
        end 

        def index
          return render_json_error(:unauthorized, :cannot_see) unless can_see

          acceptable_params *self.class.acceptable_params.keys
          @query_precision ||= {}
  
          paginate(
            index_aggregation(no_acl: true),
            each_serializer: @serializer,
            **@options
          )
        end

      end
    end
  end
end
