# frozen_string_literal: true

module Hermes
  module Api
    module Dmo
      # checker Api::Dmo::HermesController avant d'ajouter des methodes
      class LessorObjectiveHistoriesController < Hermes::Api::Dmo::ApplicationController
        set_instance_for :objectives
        before_action :not_allowed, only: [:create, :update, :destroy]
        
        class << self
          def mutate_params
            {
            }
          end 
      
          def acceptable_params
            {
              housing_offer_id: {type: 'String'},
              lessor_id: {type: 'String'},
              lessor_objective_id: {type: 'String'},
            }.merge(self.mutate_params).merge(super)
          end 
      
          def regex_params
            {

            }
          end 
        end

        def index
          acceptable_params *self.class.acceptable_params.keys
          super 
        end 
        
        def not_allowed
          return render_json_error(:unprocessable_entity, :not_allowed)
        end
  
      end
    end
  end
end
