# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class LessorObjectivesController < Hermes::Api::Dmo::ApplicationController

        class << self
          def mutate_params
            {
              activation_date: {type: 'Date'},
              department: {type: 'String'},
              district: {type: 'String'},
              threshold_type: {type: 'String'},
              priority_public: {type: 'Boolean'},
              new_offer: {type: 'Boolean'},
              target_by_typologies: {type: 'Hash'},
              lessor_id: {type: 'String'},
              operation_name: {type: 'String'},
              agency_id: {type: 'String'},
            }
          end 
      
          def acceptable_params
            {
              present_typologies: {type: 'Array'},
              realized_by_typologies: {type: 'Hash'},
              objective_difference_by_typologies: {type: 'Hash'},
              lessor_objective_history_ids: {type: 'Array'},
            }.merge(self.mutate_params).merge(super)
          end 
      
          def regex_params
            {

            }
          end 
        end

        def index
          acceptable_params *self.class.acceptable_params.keys
          super 
        end 


        def user_can_destroy?
          is_writer_and_is_owner = (@instance.user_id.to_s == current_user.id.to_s)
          is_writer_and_is_owner || current_user.has_role?('Superadmin')
        end
      end
    end
  end
end
