# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class UntensedAreasController < Hermes::Api::Dmo::ApplicationController
        before_action :check_if_allowed
  
        class << self
          def mutate_params
            {
              insee_code: {type: 'String'},
              department: {type: 'String'},
            }
          end 
      
          def acceptable_params
            {
            }.merge(self.mutate_params).merge(super)
          end 
      
          def regex_params
            {
              insee_code: {type: 'String'},
              department: {type: 'String'},
            }
          end 
        end
      
        def index
          acceptable_params *self.class.acceptable_params.keys
          regex_params *self.class.regex_params.keys
          super
        end
        
        def check_if_allowed
          return render_json_error(:unauthorized, :only_administrators_are_allowed_to_interact_with_untensed_areas) unless current_user_roles.include?('Administrator')
        end
      end
    end
  end
end
