# frozen_string_literal: true

module Hermes
  # HousingRequest serializer
  class HousingRequestFolderSerializer < Hermes::ApplicationSerializer
    type 'housing_request_folders'
 
    attributes :housing_request_id,
               :required_documents

    def required_documents
      return object.required_documents unless object.required_documents.nil? || object.required_documents.empty?

      Hermes::RequiredDocument.where(:id.in => object.required_document_ids).map do |doc|
        Hermes::RequiredDocumentSerializer.new(
          doc,
          scope: scope,
          root: false,
          base_url: @instance_options[:base_url],
          folder_id: object.id,
          main_applicant_id: object.housing_request&.main_applicant_id,
          hide_status: @instance_options[:hide_status]
        )
      end      
    end 
  end
end
