module BatchTasks
  class RequestWaitingForValidation < Base
    
    def generate_and_enqueue_notification(tagset_id: nil, user_filter: {})
      starttime = Time.now
      @log_name = "#{print_time(starttime)}_requests_to_approve.csv"

      headers = %w[
        email
        number_of_requests
      ]

      add_to_log_file(headers)

      user_ids = User.where({auth_roles: 'entreprise'}.merge(user_filter)).pluck(:id)

      user_ids.each do |user_id|
        user = User.find(user_id)
        entity_ids = Hermes::UserRight.where(user_id: user.id, type: 'entity', :right.in => ['administrator', 'user']).pluck(:entity_id)
        number_of_requests = Hermes::HousingRequest.where(
          is_active: true, 
          entity_status: "A VALIDER", 
          :entity_id.in => entity_ids, 
        ).count

        if number_of_requests > 0
          user.notify(
            key: NOTIFICATION_KEYS[:user][:requests_to_approve],
            channels: ['email'],
            datas: {
              number_of_requests: number_of_requests
            },
            is_slow: true
          )
          add_to_log_file([user.email, number_of_requests])
        end 
      end 

      create_log_doc(tagset_id)
    end 
  end
end